function object=emppCalcObjectMask(objecti)

object=objecti;







switch object.tp
    case 0 
        halfDia=ceil(sqrt((object.sizeX/2)^2+(object.sizeY/2)^2))*2 +2;
        
        partR=zeros(2*halfDia,2*halfDia);

        phi = object.angle*pi/180;
        X0=halfDia;
        Y0=halfDia;
        a=object.sizeX;
        b=object.sizeY;
        partR=emppDrawEllipse(partR,X0,Y0,a,b,phi);

        object.fillMask=partR;
        object.edgeMask=partR;
        object.halfDia=halfDia;
        
       
    case 1
        halfDia=ceil(sqrt((object.sizeX/2)^2+(object.sizeY/2)^2)) +2;
        partR=zeros(2*halfDia,2*halfDia);
        partR(halfDia-floor(object.sizeX/2)+1:halfDia+floor(object.sizeX/2),halfDia-floor(object.sizeY/2)+1:halfDia+floor(object.sizeY/2))=1;
        partR=imrotate(partR,object.angle,'nearest','crop');
        object.fillMask=partR;
        partR=edge(partR,'roberts');
        object.edgeMask=partR;
        object.halfDia=halfDia;

    case 2
         halfDia=ceil(sqrt((object.sizeX/2)^2+(object.sizeY/2)^2))*2 +2;
         partR=zeros(2*halfDia,2*halfDia);
        
         radangle = object.angle*pi/180;
         cosradangle=cos(radangle);
         sinradangle=sin(radangle);
         sideL2=object.sizeX/2.0;
         X0=halfDia;
         Y0=halfDia;
	
         cosL2=cosradangle*sideL2;
         sinL2=sinradangle*sideL2;

         p1 = [X0-cosL2,Y0 - sinL2];
         p2 = [X0 + cosL2, Y0 + sinL2];

         vv= p1-p2;
         vv=vv/sqrt(vv(1)*vv(1)+vv(2)*vv(2));
         
         vRot= [-vv(2),-vv(1)];
	
         p3=(p1+p2)/2 + vRot* object.sizeY;
   
     
     
         p1=floor(p1);
         p2=floor(p2);
         p3=floor(p3);
    %    partR(halfDia-floor(object.sizeX/2)+1:halfDia+floor(object.sizeX/2),halfDia-floor(object.sizeY/2)+1:halfDia+floor(object.sizeY/2))=1;
    %    partR=imrotate(partR,object.angle,'nearest','crop');
    %    object.fillMask=partR;
    %    partR=edge(partR,'roberts');
        partR(p1(2),p1(1))=1;
        partR(p2(2),p2(1))=1;
        partR(p3(2),p3(1))=1;
    
        feloszt=100;
        
        for i1=0:feloszt
            pt=floor(p1*i1/feloszt + p2 * (feloszt-i1)/feloszt);
            partR(pt(2),pt(1))=1;
            pt=floor(p1*i1/feloszt + p3 * (feloszt-i1)/feloszt);
            partR(pt(2),pt(1))=1;
            pt=floor(p3*i1/feloszt + p2 * (feloszt-i1)/feloszt);
            partR(pt(2),pt(1))=1;
        end;
        
        
        object.edgeMask=partR;
        object.halfDia=halfDia;

    case 3
        halfDia=ceil(sqrt((object.sizeX/2)^2+(object.sizeY/2)^2))*2 +2;
        
        partR=zeros(2*halfDia,2*halfDia);

        phi = object.angle*pi/180;
        X0=halfDia;
        Y0=halfDia;
        a=object.sizeX;
        b=object.sizeY;
        partR=emppDrawEllipse(partR,X0,Y0,a,b,phi);

        object.fillMask=partR;
        object.edgeMask=partR;
        object.halfDia=halfDia;
end;








