%--------------------------------------------------------------------------
% Displays 3-level EMPP population over an input image
% Parameters: 
%   imagename: path and name of the input image file (3 channel 8 bit image in standard formats such as bmp, jpg, png, etc.)
%   gtfilename: text file containing the 3-layer GT population

function emppDisplayGT(imagename,gtfilename)

inputimage=imread(imagename);
population=emppReadGT(gtfilename);

outimage=emppShowPopulation(inputimage,population);

figure(1)
imshow(outimage);
